; #################################################### Includes ##################################################

XIncludeFile "Includes/D3HT.pbi"

DisableExplicit

; #################################################### Startup ###################################################

OpenConsole()

*D3HT_Table = D3HT_Create(4, SizeOf(Integer), 65536)

; #################################################### Main ######################################################

; #### Display the amount of elements
PrintN("Elemente in der Liste: "+Str(D3HT_Get_Elements(*D3HT_Table)))

; #### Create the element "Test" if not existant, set value to 123456
D3HT_Element_Set_Integer(*D3HT_Table, @"Test", 123456)
PrintN("'Test' gesetzt auf 123456")

; #### Overwrite the element "Test" if not existant, set value to 456789
Temp_Key.s = "Test"
Temp_Value.i = 456789
D3HT_Element_Set(*D3HT_Table, @Temp_Key, @Temp_Value)
PrintN("'Test' gesetzt auf 456789")

; #### Display the amount of elements
PrintN("Elemente in der Liste: "+Str(D3HT_Get_Elements(*D3HT_Table)))

; #### Return the value of "Test", it should return 456789
PrintN("Wert von 'Test': "+Str(D3HT_Element_Get_Integer(*D3HT_Table, @"Test")))

; #### Delete all elements from the table
D3HT_Clear(*D3HT_Table)
PrintN("Hashtable geleert")

; #### Display the amount of elements
PrintN("Elemente in der Liste: "+Str(D3HT_Get_Elements(*D3HT_Table)))

; #### Destroy the table, all memory gets freed. *D3HT_Table is now invalid
D3HT_Destroy(*D3HT_Table)
*D3HT_Table = 0

Input()
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 38
; EnableXP